/*
*	Copyright (C) 2011
*	Chair of Process Control Engineering,
*	Aachen University of Technology.
*	All rights reserved.
*
*	Redistribution and use in source and binary forms, with or without
*	modification, are permitted provided that the following conditions
*	are met:
*	1. Redistributions of source code must retain the above copyright
*	   notice, this list of conditions and the following disclaimer.
*	2. Redistributions in binary form must print or display the above
*	   copyright notice either during startup or must have a means for
*	   the user to view the copyright notice.
*	3. Redistributions in binary form must reproduce the above copyright
*	   notice, this list of conditions and the following disclaimer in
*		the documentation and/or other materials provided with the
*		distribution.
*	4. Neither the name of the Chair of Process Control Engineering nor
*		the name of the Aachen University of Technology may be used to
*		endorse or promote products derived from this software without
*		specific prior written permission.
*
*	THIS SOFTWARE IS PROVIDED BY THE CHAIR OF PROCESS CONTROL ENGINEERING
*	``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*	LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*	A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE CHAIR OF
*	PROCESS CONTROL ENGINEERING BE LIABLE FOR ANY DIRECT, INDIRECT,
*	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*	OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*	AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
*	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
*	WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*	POSSIBILITY OF SUCH DAMAGE.
*/
/******************************************************************************
*
*   FILE
*   ----
*   TOFF.c
*
*   History
*   -------
*   2011-04-18   File created
*
*******************************************************************************
*
*   This file is generated by the 'fb_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_iec61131stdfb
#define OV_COMPILE_LIBRARY_iec61131stdfb
#endif


#include "iec61131stdfb.h"
#include "libov/ov_macros.h"


OV_DLLFNCEXPORT void iec61131stdfb_TOFF_typemethod(
	OV_INSTPTR_fb_functionblock	pfb,
	OV_TIME						*pltc
) {
    /*    
    *   local variables
    */
    OV_INSTPTR_iec61131stdfb_TOFF pinst = Ov_StaticPtrCast(iec61131stdfb_TOFF, pfb);
	OV_TIME tTime;
	OV_TIME_SPAN tTimeSpan;
	
	if((!pinst->v_IN) && (!pinst->v_Counting))
	{
		ov_time_gettime(&pinst->v_TriggerTime);
		pinst->v_Counting = TRUE;
	}
	
	if(pinst->v_Counting)
	{
		if(!pinst->v_IN)
		{
			ov_time_gettime(&tTime);
			ov_time_diff(&tTimeSpan, &tTime, &pinst->v_TriggerTime);
					//set ET to time since triggering, if this is not longer than PT
			if((tTimeSpan.secs < pinst->v_PT.secs) || ((tTimeSpan.secs == pinst->v_PT.secs) && (tTimeSpan.usecs < pinst->v_PT.usecs)))
			{
				pinst->v_ET.secs = tTimeSpan.secs;
				pinst->v_ET.usecs = tTimeSpan.usecs;
			}
			else		//reset Q
			{
				pinst->v_Q = FALSE;
				pinst->v_ET.secs = pinst->v_PT.secs;
				pinst->v_ET.usecs = pinst->v_PT.usecs;
				
			}
		}
		else
		{
			pinst->v_ET.secs = 0;
			pinst->v_ET.secs = 0;
			pinst->v_Counting = FALSE;
			pinst->v_Q = TRUE;
		}
	}
	else
		if(pinst->v_IN)		//could be necessary on startup
			pinst->v_Q = TRUE;
	
    return;
}

