
/******************************************************************************
*
*   FILE
*   ----
*   ClientBase.c
*
*   History
*   -------
*   2013-02-22   File created
*
*******************************************************************************
*
*   This file is generated by the 'acplt_builder' command
*
******************************************************************************/


#ifndef OV_COMPILE_LIBRARY_ksbase
#define OV_COMPILE_LIBRARY_ksbase
#endif


#include "ksbase.h"
#include "ksbase_helper.h"
#include "libov/ov_macros.h"
#include "ov_ksserver_backend.h"

/*****************************************************************************************************************************************************************************
 * 		SetAccessors
 *****************************************************************************************************************************************************************************/

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_serverHost_set(
		OV_INSTPTR_ksbase_ClientBase          pobj,
		const OV_STRING  value
) {
	OV_RESULT					result;
	OV_INSTPTR_ksbase_Channel	pChannel = NULL;
	OV_VTBLPTR_ksbase_Channel	pVtblChannel	=	NULL;

	if(ov_string_compare(pobj->v_serverHost, value) != OV_STRCMP_EQUAL)
	{	/*	new host	*/
		/*	reset serverPort	*/
		result = ov_string_setvalue(&(pobj->v_serverPort), "");
		if(Ov_Fail(result))
			return result;
		/*	get pointer to channel and close connection if one is open	*/
		/*	check if there is a channel and get pointer to it	*/
		pChannel = Ov_GetParent(ksbase_AssocChannelDataHandler, pobj);
		if(pChannel)
		{
			Ov_GetVTablePtr(ksbase_Channel, pVtblChannel, pChannel);
			if(pVtblChannel)
			{
				if(pChannel->v_ConnectionState != KSBASE_CONNSTATE_CLOSED)
					pVtblChannel->m_CloseConnection(pChannel);
			}

		}

		return ov_string_setvalue(&pobj->v_serverHost,value);
	}
	return OV_ERR_OK;

}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_serverName_set(
		OV_INSTPTR_ksbase_ClientBase          pobj,
		const OV_STRING  value
) {
	OV_RESULT					result;
	OV_INSTPTR_ksbase_Channel	pChannel = NULL;
	OV_VTBLPTR_ksbase_Channel	pVtblChannel	=	NULL;

	if(ov_string_compare(pobj->v_serverName, value) != OV_STRCMP_EQUAL)
	{	/*	new host	*/
		/*	reset serverPort	*/
		result = ov_string_setvalue(&(pobj->v_serverPort), "");
		if(Ov_Fail(result))
			return result;

		/*	get pointer to channel and close connection if one is open	*/
		pChannel = Ov_GetParent(ksbase_AssocChannelDataHandler, pobj);
		if(pChannel)
		{
			Ov_GetVTablePtr(ksbase_Channel, pVtblChannel, pChannel);
			if(pVtblChannel)
			{
				if(pChannel->v_ConnectionState != KSBASE_CONNSTATE_CLOSED)
					pVtblChannel->m_CloseConnection(pChannel);
			}

		}

		return ov_string_setvalue(&pobj->v_serverName,value);
	}
	return OV_ERR_OK;

}

/**
 * resets all variables from the ClientBase class and closes the connection
 */
OV_DLLFNCEXPORT	OV_RESULT ksbase_ClientBase_reset(
	OV_INSTPTR_ksbase_ClientBase thisCl
){
	OV_INSTPTR_ksbase_Channel 	pChannel = NULL;
	OV_VTBLPTR_ksbase_Channel	pVtblChannel = NULL;

	thisCl->v_actimode = 0;
	ov_string_setvalue(&thisCl->v_serverHost, "");
	ov_string_setvalue(&thisCl->v_serverName, "");
	ov_string_setvalue(&thisCl->v_serverPort, "");

	thisCl->v_state = KSBASE_CLST_INITIAL;
	thisCl->v_runningKSservice = 0;

	thisCl->v_callback.instanceCalled = NULL;
	thisCl->v_callback.callbackFunction = NULL;

	pChannel = Ov_GetParent(ksbase_AssocChannelDataHandler, thisCl);
	Ov_GetVTablePtr(ksbase_Channel, pVtblChannel, pChannel);

	if(pVtblChannel){
		pVtblChannel->m_CloseConnection(pChannel);
	}
	if(pChannel){
		ksbase_free_KSDATAPACKET(&pChannel->v_inData);
	}
	return OV_ERR_OK;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestRegister(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_STRING servername,
	const OV_UINT	version,
	const OV_UINT port,
	const OV_UINT ttl,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}


OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processRegister(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result
){
    return OV_ERR_NOTIMPLEMENTED;
}


OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestUnRegister(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_STRING servername,
	const OV_UINT version,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processUnRegister(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestGetServer(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_STRING servername,
	const OV_UINT leastVersion,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processGetServer(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_STRING* servername,
	OV_UINT* regVersion,
	OV_STRING* port,
	OV_TIME* expirationTime,
	OV_UINT* serverState
) {
    return OV_ERR_NOTIMPLEMENTED;
}

/*	the dummy-parameter is here to be complete. these 4 bytes are not decoded right now, but they are always sent. maybe they will be used in the future, so...	*/
OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestGetPP(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_STRING path,
	const OV_OBJ_TYPE typeMask,
	const OV_STRING	nameMask,
	const OV_UINT dummy,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processGetPP(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_len,
	OV_OBJ_PROJECTED_PROPS** items_val
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestGetEP(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_STRING path,
	const OV_OBJ_TYPE typeMask,
	const OV_STRING	nameMask,
	const OV_EP_FLAGS scopeFlags,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processGetEP(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_len,
	OV_OBJ_ENGINEERED_PROPS** items_val
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestGetVar(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_STRING* paths,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processGetVar(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_len,
	OV_GETVAR_ITEM** items_val
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestSetVar(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_SETVAR_ITEM* items_val,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processSetVar(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_length,
	OV_RESULT** items_results
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestGetCanonicalPath(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_STRING* paths,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processGetCanonicalPath(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_length,
	OV_RESULT* items_results,
	OV_STRING** items_canonicalPaths
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestCreateObject(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_CREATEOBJ_ITEM* items_val,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processCreateObject(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_length,
	OV_CREATEOBJECTITEM_RES** items_val
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestDeleteObject(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_STRING* paths,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processDeleteObject(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_length,
	OV_RESULT** items_results
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestRenameObject(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_RENAMEOBJECT_ITEM* items_val,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
){
	return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processRenameObject(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_length,
	OV_RESULT** items_results
){
	return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestLink(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_LINK_ITEM* items_val,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processLink(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_length,
	OV_RESULT** items_results
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_requestUnLink(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	const OV_UINT items_length,
	const OV_UNLINK_ITEM* items_val,
	const OV_INSTPTR_ov_domain	callbackThat,
	void (*callback)(const OV_INSTPTR_ov_domain this, const OV_INSTPTR_ov_domain that)
) {
    return OV_ERR_NOTIMPLEMENTED;
}

OV_DLLFNCEXPORT OV_RESULT ksbase_ClientBase_processUnLink(
	const OV_INSTPTR_ksbase_ClientBase this,
	const OV_INSTPTR_ksbase_ClientTicketGenerator TicketGenerator,
	OV_RESULT* result,
	OV_UINT* items_length,
	OV_RESULT** items_results
) {
    return OV_ERR_NOTIMPLEMENTED;
}

